/*
   +----------------------------------------------------------------------+
   | This source file is subject to version 3.0 of the PHP license,       |
   | that is bundled with this package in the file LICENSE, and is        |
   | available through the world-wide-web at the following url:           |
   | http://www.php.net/license/3_0.txt.                                  |
   | If you did not receive a copy of the PHP license and are unable to   |
   | obtain it through the world-wide-web, please send a note to          |
   | license@php.net so we can mail you a copy immediately.               |
   +----------------------------------------------------------------------+
   | Authors: Hartmut Holzgraefe <hartmut@php.net>                        |
   +----------------------------------------------------------------------+
*/

/* $ Id: $ */ 

#include "php_braille.h"

#if HAVE_BRAILLE

/* {{{ braille_functions[] */
function_entry braille_functions[] = {
	PHP_FE(braille_init        , NULL)
	PHP_FE(braille_close       , NULL)
	PHP_FE(braille_geterror    , NULL)
	PHP_FE(braille_drivernum   , NULL)
	PHP_FE(braille_drivername  , NULL)
	PHP_FE(braille_drivermodels, NULL)
	PHP_FE(braille_drivertype  , NULL)
	PHP_FE(braille_driverauto  , NULL)
	PHP_FE(braille_tablenum    , NULL)
	PHP_FE(braille_tablename   , NULL)
	PHP_FE(braille_tabledesc   , NULL)
	PHP_FE(braille_config      , NULL)
	PHP_FE(braille_info        , NULL)
	PHP_FE(braille_size        , NULL)
	PHP_FE(braille_statussize  , NULL)
	PHP_FE(braille_display     , NULL)
	PHP_FE(braille_write       , NULL)
	PHP_FE(braille_filter      , NULL)
	PHP_FE(braille_render      , NULL)
	PHP_FE(braille_statusdisplay, NULL)
	PHP_FE(braille_statuswrite , NULL)
	PHP_FE(braille_statusfilter, NULL)
	PHP_FE(braille_statusrender, NULL)
	PHP_FE(braille_timeout     , NULL)
	PHP_FE(braille_ascii2braille, NULL)
	PHP_FE(braille_braille2ascii, NULL)
	PHP_FE(braille_usetable    , NULL)
	PHP_FE(braille_debug       , NULL)
	{ NULL, NULL, NULL }
};
/* }}} */


/* {{{ braille_module_entry
 */
zend_module_entry braille_module_entry = {
	STANDARD_MODULE_HEADER,
	"braille",
	braille_functions,
	PHP_MINIT(braille),     /* Replace with NULL if there is nothing to do at php startup   */ 
	PHP_MSHUTDOWN(braille), /* Replace with NULL if there is nothing to do at php shutdown  */
	PHP_RINIT(braille),     /* Replace with NULL if there is nothing to do at request start */
	PHP_RSHUTDOWN(braille), /* Replace with NULL if there is nothing to do at request end   */
	PHP_MINFO(braille),
	"0.1.0", 
	STANDARD_MODULE_PROPERTIES
};
/* }}} */

#ifdef COMPILE_DL_BRAILLE
ZEND_GET_MODULE(braille)
#endif


/* {{{ PHP_MINIT_FUNCTION */
PHP_MINIT_FUNCTION(braille)
{
	REGISTER_LONG_CONSTANT("BRL_DEVICE", BRL_DEVICE, CONST_PERSISTENT | CONST_CS);
	REGISTER_LONG_CONSTANT("BRL_DRIVER", BRL_DRIVER, CONST_PERSISTENT | CONST_CS);
	REGISTER_LONG_CONSTANT("BRL_TERMINAL", BRL_TERMINAL, CONST_PERSISTENT | CONST_CS);
	REGISTER_LONG_CONSTANT("BRL_TABLE", BRL_TABLE, CONST_PERSISTENT | CONST_CS);
	REGISTER_LONG_CONSTANT("BRL_PATH", BRL_PATH, CONST_PERSISTENT | CONST_CS);
	REGISTER_LONG_CONSTANT("BRL_VERSION", BRL_VERSION, CONST_PERSISTENT | CONST_CS);
	REGISTER_LONG_CONSTANT("BRL_PATHDRV", BRL_PATHDRV, CONST_PERSISTENT | CONST_CS);
	REGISTER_LONG_CONSTANT("BRL_PATHTBL", BRL_PATHTBL, CONST_PERSISTENT | CONST_CS);
	REGISTER_LONG_CONSTANT("BRL_PATHCONF", BRL_PATHCONF, CONST_PERSISTENT | CONST_CS);
	REGISTER_LONG_CONSTANT("BRL_TYPE_UNKNOWN", BRL_TYPE_UNKNOWN, CONST_PERSISTENT | CONST_CS);
	REGISTER_LONG_CONSTANT("BRL_TYPE_SPECIAL", BRL_TYPE_SPECIAL, CONST_PERSISTENT | CONST_CS);
	REGISTER_LONG_CONSTANT("BRL_TYPE_SERIAL", BRL_TYPE_SERIAL, CONST_PERSISTENT | CONST_CS);
	REGISTER_LONG_CONSTANT("BRL_TYPE_USB", BRL_TYPE_USB, CONST_PERSISTENT | CONST_CS);
	REGISTER_LONG_CONSTANT("BRL_NONE", BRL_NONE, CONST_PERSISTENT | CONST_CS);
	REGISTER_LONG_CONSTANT("BRL_KEY", BRL_KEY, CONST_PERSISTENT | CONST_CS);
	REGISTER_LONG_CONSTANT("BRL_CURSOR", BRL_CURSOR, CONST_PERSISTENT | CONST_CS);
	REGISTER_LONG_CONSTANT("BRL_CMD", BRL_CMD, CONST_PERSISTENT | CONST_CS);
	REGISTER_LONG_CONSTANT("BRL_ACC", BRL_ACC, CONST_PERSISTENT | CONST_CS);

	/* add your stuff here */

	return SUCCESS;
}
/* }}} */


/* {{{ PHP_MSHUTDOWN_FUNCTION */
PHP_MSHUTDOWN_FUNCTION(braille)
{

	/* add your stuff here */

	return SUCCESS;
}
/* }}} */


/* {{{ PHP_RINIT_FUNCTION */
PHP_RINIT_FUNCTION(braille)
{
	/* add your stuff here */

	return SUCCESS;
}
/* }}} */


/* {{{ PHP_RSHUTDOWN_FUNCTION */
PHP_RSHUTDOWN_FUNCTION(braille)
{
	/* add your stuff here */

	return SUCCESS;
}
/* }}} */


/* {{{ PHP_MINFO_FUNCTION */
PHP_MINFO_FUNCTION(braille)
{
	php_info_print_box_start(0);
	php_printf("<p>libbraille extension</p>\n");
	php_printf("<p>Version 0.1.0alpha (2006-08-31)</p>\n");
	php_printf("<p><b>Authors:</b></p>\n");
	php_printf("<p>Hartmut Holzgraefe &lt;hartmut@php.net&gt; (lead)</p>\n");
	php_info_print_box_end();
	/* add your stuff here */

}
/* }}} */


/* {{{ proto bool braille_init(void)
   */
PHP_FUNCTION(braille_init)
{
	if (ZEND_NUM_ARGS()>0)  {
		WRONG_PARAM_COUNT;
	}

	do {
		RETURN_BOOL(braille_init());
	} while (0);
}
/* }}} braille_init */


/* {{{ proto bool braille_close(void)
   */
PHP_FUNCTION(braille_close)
{
	if (ZEND_NUM_ARGS()>0)  {
		WRONG_PARAM_COUNT;
	}

	do {
		RETURN_BOOL(braille_close());
	} while (0);
}
/* }}} braille_close */


/* {{{ proto string braille_geterror(void)
   */
PHP_FUNCTION(braille_geterror)
{
	if (ZEND_NUM_ARGS()>0)  {
		WRONG_PARAM_COUNT;
	}

	do {
		RETURN_STRING(braille_geterror(), 1);
	} while (0);
}
/* }}} braille_geterror */


/* {{{ proto int braille_drivernum(void)
   */
PHP_FUNCTION(braille_drivernum)
{
	if (ZEND_NUM_ARGS()>0)  {
		WRONG_PARAM_COUNT;
	}

	do {
		RETURN_LONG(braille_drivernum());
	} while (0);
}
/* }}} braille_drivernum */


/* {{{ proto string braille_drivername(int num)
   */
PHP_FUNCTION(braille_drivername)
{
	long num = 0;

	if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "l", &num) == FAILURE) { 
		return;
	}
	do {
		if ((num < 0) || (num >= braille_drivernum())) {
			  RETURN_FALSE;
			}
		
			RETURN_STRING(braille_drivername(num), 1);
	} while (0);
}
/* }}} braille_drivername */


/* {{{ proto string braille_drivermodels(int num)
   */
PHP_FUNCTION(braille_drivermodels)
{
	long num = 0;

	if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "l", &num) == FAILURE) { 
		return;
	}
	do {
		if ((num < 0) || (num >= braille_drivernum())) {
			  RETURN_FALSE;
			}
		
			RETURN_STRING(braille_drivermodels(num), 1);
	} while (0);
}
/* }}} braille_drivermodels */


/* {{{ proto int braille_drivertype(int num)
   */
PHP_FUNCTION(braille_drivertype)
{
	long num = 0;

	if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "l", &num) == FAILURE) { 
		return;
	}
	do {
		if ((num < 0) || (num >= braille_drivernum())) {
			  RETURN_FALSE;
			}
		
			RETURN_LONG(braille_drivertype(num));
	} while (0);
}
/* }}} braille_drivertype */


/* {{{ proto bool braille_driverauto(int num)
   */
PHP_FUNCTION(braille_driverauto)
{
	long num = 0;

	if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "l", &num) == FAILURE) { 
		return;
	}
	do {
		if ((num < 0) || (num >= braille_drivernum())) {
			  RETURN_FALSE;
			}
		
			RETURN_BOOL(braille_driverauto(num));
	} while (0);
}
/* }}} braille_driverauto */


/* {{{ proto int braille_tablenum(void)
   */
PHP_FUNCTION(braille_tablenum)
{
	if (ZEND_NUM_ARGS()>0)  {
		WRONG_PARAM_COUNT;
	}

	do {
		RETURN_LONG(braille_tablenum());
	} while (0);
}
/* }}} braille_tablenum */


/* {{{ proto string braille_tablename(int num)
   */
PHP_FUNCTION(braille_tablename)
{
	long num = 0;

	if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "l", &num) == FAILURE) { 
		return;
	}
	do {
		if ((num < 0) || (num >= braille_tablenum())) {
			  RETURN_FALSE;
			}
		
			RETURN_STRING(braille_tablename(num), 1);
	} while (0);
}
/* }}} braille_tablename */


/* {{{ proto string braille_tabledesc(int num)
   */
PHP_FUNCTION(braille_tabledesc)
{
	long num = 0;

	if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "l", &num) == FAILURE) { 
		return;
	}
	do {
		if ((num < 0) || (num >= braille_tablenum())) {
			  RETURN_FALSE;
			}
		
			RETURN_STRING(braille_tabledesc(num), 1);
	} while (0);
}
/* }}} braille_tabledesc */


/* {{{ proto bool braille_config(int config, string arg)
   */
PHP_FUNCTION(braille_config)
{
	long config = 0;
	const char * arg = NULL;
	int arg_len = 0;

	if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ls", &config, &arg, &arg_len) == FAILURE) { 
		return;
	}
	do {
		switch(config) 
			{
			  case BRL_DEVICE:
			  case BRL_DRIVER:	
			  case BRL_TERMINAL:
			  case BRL_TABLE:
			  case BRL_PATH:
			  case BRL_VERSION:
			  case BRL_PATHDRV:
			  case BRL_PATHTBL:
			  case BRL_PATHCONF:
				RETURN_BOOL(braille_config((brl_config)config, arg));
			  default:
				RETURN_FALSE;
			}
	} while (0);
}
/* }}} braille_config */


/* {{{ proto string braille_info(int config)
   */
PHP_FUNCTION(braille_info)
{
	long config = 0;

	if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "l", &config) == FAILURE) { 
		return;
	}
	do {
		switch(config) 
			{
			  case BRL_DEVICE:
			  case BRL_DRIVER:	
			  case BRL_TERMINAL:
			  case BRL_TABLE:
			  case BRL_PATH:
			  case BRL_VERSION:
			  case BRL_PATHDRV:
			  case BRL_PATHTBL:
			  case BRL_PATHCONF:
				RETURN_STRING(braille_info((brl_config)config), 1);
			  default:
				RETURN_FALSE;
			}
	} while (0);
}
/* }}} braille_info */


/* {{{ proto int braille_size(void)
   */
PHP_FUNCTION(braille_size)
{
	if (ZEND_NUM_ARGS()>0)  {
		WRONG_PARAM_COUNT;
	}

	do {
		RETURN_LONG(braille_size());
	} while (0);
}
/* }}} braille_size */


/* {{{ proto int braille_statussize(void)
   */
PHP_FUNCTION(braille_statussize)
{
	if (ZEND_NUM_ARGS()>0)  {
		WRONG_PARAM_COUNT;
	}

	do {
		RETURN_LONG(braille_statussize());
	} while (0);
}
/* }}} braille_statussize */


/* {{{ proto bool braille_display(string text)
   */
PHP_FUNCTION(braille_display)
{
	const char * text = NULL;
	int text_len = 0;

	if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "s", &text, &text_len) == FAILURE) { 
		return;
	}
	do {
		RETURN_BOOL(braille_display(text));
	} while (0);
}
/* }}} braille_display */


/* {{{ proto bool braille_write(string text, int n)
   */
PHP_FUNCTION(braille_write)
{
	const char * text = NULL;
	int text_len = 0;
	long n = 0;

	if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "sl", &text, &text_len, &n) == FAILURE) { 
		return;
	}
	do {
		RETURN_BOOL(braille_write(text, n));
	} while (0);
}
/* }}} braille_write */


/* {{{ proto bool braille_filter(int mask, int pos)
   */
PHP_FUNCTION(braille_filter)
{
	long mask = 0;
	long pos = 0;

	if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ll", &mask, &pos) == FAILURE) { 
		return;
	}
	do {
		RETURN_BOOL(braille_filter(mask, pos));
	} while (0);
}
/* }}} braille_filter */


/* {{{ proto bool braille_render(void)
   */
PHP_FUNCTION(braille_render)
{
	if (ZEND_NUM_ARGS()>0)  {
		WRONG_PARAM_COUNT;
	}

	do {
		RETURN_BOOL(braille_render());
	} while (0);
}
/* }}} braille_render */


/* {{{ proto bool braille_statusdisplay(string text)
   */
PHP_FUNCTION(braille_statusdisplay)
{
	const char * text = NULL;
	int text_len = 0;

	if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "s", &text, &text_len) == FAILURE) { 
		return;
	}
	do {
		RETURN_BOOL(braille_statusdisplay(text));
	} while (0);
}
/* }}} braille_statusdisplay */


/* {{{ proto bool braille_statuswrite(string text, int n)
   */
PHP_FUNCTION(braille_statuswrite)
{
	const char * text = NULL;
	int text_len = 0;
	long n = 0;

	if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "sl", &text, &text_len, &n) == FAILURE) { 
		return;
	}
	do {
		RETURN_BOOL(braille_statuswrite(text, n));
	} while (0);
}
/* }}} braille_statuswrite */


/* {{{ proto bool braille_statusfilter(int mask, int pos)
   */
PHP_FUNCTION(braille_statusfilter)
{
	long mask = 0;
	long pos = 0;

	if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ll", &mask, &pos) == FAILURE) { 
		return;
	}
	do {
		RETURN_BOOL(braille_statusfilter(mask, pos));
	} while (0);
}
/* }}} braille_statusfilter */


/* {{{ proto bool braille_statusrender(void)
   */
PHP_FUNCTION(braille_statusrender)
{
	if (ZEND_NUM_ARGS()>0)  {
		WRONG_PARAM_COUNT;
	}

	do {
		RETURN_BOOL(braille_statusrender());
	} while (0);
}
/* }}} braille_statusrender */


/* {{{ proto bool braille_timeout(int timeout)
   */
PHP_FUNCTION(braille_timeout)
{
	long timeout = 0;

	if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "l", &timeout) == FAILURE) { 
		return;
	}
	do {
		RETURN_BOOL(braille_timeout(timeout));
	} while (0);
}
/* }}} braille_timeout */


/* {{{ proto string braille_ascii2braille(string from)
   */
PHP_FUNCTION(braille_ascii2braille)
{
	const char * from = NULL;
	int from_len = 0;

	if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "s", &from, &from_len) == FAILURE) { 
		return;
	}
	do {
		char *to = emalloc(from_len);
			int i;
		
			for (i = 0; i < from_len; i++) {
			  to[i] = braille_ascii2braille(from[i]);
			}
			RETURN_STRINGL(to, from_len, 0);
	} while (0);
}
/* }}} braille_ascii2braille */


/* {{{ proto string braille_braille2ascii(string from)
   */
PHP_FUNCTION(braille_braille2ascii)
{
	const char * from = NULL;
	int from_len = 0;

	if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "s", &from, &from_len) == FAILURE) { 
		return;
	}
	do {
		char *to = emalloc(from_len);
			int i;
		
			for (i = 0; i < from_len; i++) {
			  to[i] = braille_braille2ascii(from[i]);
			}
			RETURN_STRINGL(to, from_len, 0);
	} while (0);
}
/* }}} braille_braille2ascii */


/* {{{ proto bool braille_usetable(string table)
   */
PHP_FUNCTION(braille_usetable)
{
	const char * table = NULL;
	int table_len = 0;

	if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "s", &table, &table_len) == FAILURE) { 
		return;
	}
	do {
		RETURN_BOOL(braille_useatable(table));
	} while (0);
}
/* }}} braille_usetable */


/* {{{ proto void braille_debug(int level)
   */
PHP_FUNCTION(braille_debug)
{
	long level = 0;

	if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "l", &level) == FAILURE) { 
		return;
	}
	do {
		braille_debug(level);
	} while (0);
}
/* }}} braille_debug */

#endif /* HAVE_BRAILLE */


/*
 * Local variables:
 * tab-width: 4
 * c-basic-offset: 4
 * End:
 * vim600: noet sw=4 ts=4 fdm=marker
 * vim<600: noet sw=4 ts=4
 */
